POJ3264(线段树求区间最大值和最小值)

2024-08-25 08:08

本文主要是介绍POJ3264(线段树求区间最大值和最小值),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Balanced Lineup
Time Limit: 5000MS Memory Limit: 65536K
Total Submissions: 38054 Accepted: 17819
Case Time Limit: 2000MS

Description

For the daily milking, Farmer John's N cows (1 ≤ N ≤ 50,000) always line up in the same order. One day Farmer John decides to organize a game of Ultimate Frisbee with some of the cows. To keep things simple, he will take a contiguous range of cows from the milking lineup to play the game. However, for all the cows to have fun they should not differ too much in height.

Farmer John has made a list of Q (1 ≤ Q ≤ 200,000) potential groups of cows and their heights (1 ≤ height ≤ 1,000,000). For each group, he wants your help to determine the difference in height between the shortest and the tallest cow in the group.

Input

Line 1: Two space-separated integers, N and Q.
Lines 2.. N+1: Line i+1 contains a single integer that is the height of cow i
Lines N+2.. N+ Q+1: Two integers A and B (1 ≤ ABN), representing the range of cows from A to B inclusive.

Output

Lines 1.. Q: Each line contains a single integer that is a response to a reply and indicates the difference in height between the tallest and shortest cow in the range.

Sample Input

6 3
1
7
3
4
2
5
1 5
4 6
2 2

Sample Output

6
3
0

题目大意:

给定一群羊,再给定一个区间,求区间中最大值 - 最小值是多少,本题如果有朴素暴力做,肯定会超时,就连我用线段树+cin都不能过,要改为scanf。

AC代码:


#include<iostream>
#include<algorithm>
#include<cstring>
#include<cstdio>
using namespace std;const int INF = 0xfffffff;
const int maxnode = 50001 * 4;int op,qL,qR,p,v; //qL和qR为全局变量,询问区间[qL,qR];struct IntervalTree
{int minv[maxnode];int maxv[maxnode];void update(int o,int L,int R){int M = L + (R - L) / 2;if(L == R){minv[o] = v;maxv[o] = v;}else{if(p <= M) update(o * 2,L,M);elseupdate(o * 2 + 1,M+1,R);minv[o] = min(minv[o * 2],minv[o * 2 + 1]);maxv[o] = max(maxv[o * 2],maxv[o * 2 + 1]);}}int QueryMin(int o,int L,int R){int M = L +(R - L) / 2, ans = INF;if(qL <= L && R <= qR) return minv[o];if(qL <= M) ans = min(ans,QueryMin(o * 2,L,M));if(M < qR) ans = min(ans,QueryMin(o * 2 + 1,M+1,R));return ans;}int QueryMax(int o,int L,int R){int M = L +(R - L) / 2, ans = -INF;if(qL <= L && R <= qR) return maxv[o];if(qL <= M) ans = max(ans,QueryMax(o * 2,L,M));if(M < qR) ans = max(ans,QueryMax(o * 2 + 1,M+1,R));return ans;}
};IntervalTree tree;
int main()
{int m,n;int i;//freopen("111","r",stdin);while(cin>>m>>n){memset(&tree, 0, sizeof(tree));for(i=1;i<=m;i++){p = i;scanf("%d",&v);tree.update(1,1,m);}for(i=1;i<=n;i++){scanf("%d%d",&qL,&qR);printf("%d\n",tree.QueryMax(1,1,m) - tree.QueryMin(1,1,m));}}return 0;
}

这篇关于POJ3264(线段树求区间最大值和最小值)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1105006

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

圆与线段的交点

poj 3819  给出一条线段的两个端点,再给出n个圆,求出这条线段被所有圆覆盖的部分占了整条线段的百分比。 圆与线段的交点 : 向量AB 的参数方程  P = A + t * (B - A)      0<=t<=1 ; 将点带入圆的方程即可。  注意: 有交点 0 <= t <= 1 ; 此题求覆盖的部分。 则 若求得 t  满足 ; double ask(d